import{MaterialLoader as e,Texture as t,BufferGeometry as s,BufferAttribute as r,Box3 as i,Sphere as a,MeshStandardMaterial as n,VertexColors as o,LineBasicMaterial as l,PointsMaterial as u,FileLoader as c}from"three";class MaterialUtils{static addMaterial(e,t,s,r,i){let a;t.name=s,r?(e[s]=t,i&&console.info('Material with name "'+s+'" was forcefully overridden.')):(a=e[s],a?a.uuid!=a.uuid&&i&&console.log('Same material name "'+a.name+'" different uuid ['+a.uuid+"|"+t.uuid+"]"):(e[s]=t,i&&console.info('Material with name "'+s+'" was added.')))}static getMaterialsJSON(e){const t={};let s;for(const r in e)s=e[r],"function"==typeof s.toJSON&&(t[r]=s.toJSON());return t}static cloneMaterial(e,t,s){let r;if(t){let i=t.materialNameOrg;i=null!=i?i:"";const a=e[i];a?(r=a.clone(),Object.assign(r,t.materialProperties),MaterialUtils.addMaterial(e,r,t.materialProperties.name,!0)):s&&console.info('Requested material "'+i+'" is not available!')}return r}}class DeUglify{static buildThreeConst(){return"const BufferGeometry = THREE.BufferGeometry;\nconst BufferAttribute = THREE.BufferAttribute;\nconst Box3 = THREE.Box3;\nconst Sphere = THREE.Sphere;\nconst Texture = THREE.Texture;\nconst MaterialLoader = THREE.MaterialLoader;\n"}static buildUglifiedMapping(){return DeUglify.buildUglifiedNameAssignment((function _BufferGeometry(){return s}),"BufferGeometry",/_BufferGeometry/)+DeUglify.buildUglifiedNameAssignment((function _BufferAttribute(){return r}),"BufferAttribute",/_BufferAttribute/)+DeUglify.buildUglifiedNameAssignment((function _Box3(){return i}),"Box3",/_Box3/)+DeUglify.buildUglifiedNameAssignment((function _Sphere(){return a}),"Sphere",/_Sphere/)+DeUglify.buildUglifiedNameAssignment((function _Texture(){return t}),"Texture",/_Texture/)+DeUglify.buildUglifiedNameAssignment((function _MaterialLoader(){return e}),"MaterialLoader",/_MaterialLoader/)}static buildUglifiedNameAssignment(e,t,s){let r=e.toString();r=r.replace(s,"").replace(/[\r\n]+/gm,""),r=r.replace(/.*return/,"").replace(/\}/,"").replace(/;/gm,"");const i=r.trim();return i===t?"":"const "+i+" = "+t+";\n"}}class DataTransport{constructor(e,t){this.main={cmd:void 0!==e?e:"unknown",id:void 0!==t?t:0,type:"DataTransport",progress:0,buffers:{},params:{}},this.transferables=[]}loadData(e){return this.main.cmd=e.cmd,this.main.id=e.id,this.main.type="DataTransport",this.setProgress(e.progress),this.setParams(e.params),e.buffers&&Object.entries(e.buffers).forEach((([e,t])=>{this.main.buffers[e]=t})),this}getCmd(){return this.main.cmd}getId(){return this.main.id}setParams(e){return null!=e&&(this.main.params=e),this}getParams(){return this.main.params}setProgress(e){return this.main.progress=e,this}addBuffer(e,t){return this.main.buffers[e]=t,this}getBuffer(e){return this.main.buffers[e]}package(e){for(let t of Object.values(this.main.buffers))if(null!=t){const s=e?t.slice(0):t;this.transferables.push(s)}return this}getMain(){return this.main}getTransferables(){return this.transferables}postMessage(e){return e.postMessage(this.main,this.transferables),this}}class MaterialsTransport extends DataTransport{constructor(e,t){super(e,t),this.main.type="MaterialsTransport",this.main.materials={},this.main.multiMaterialNames={},this.main.cloneInstructions=[]}loadData(t){super.loadData(t),this.main.type="MaterialsTransport",Object.assign(this.main,t);const s=new e;return Object.entries(this.main.materials).forEach((([e,t])=>{this.main.materials[e]=s.parse(t)})),this}_cleanMaterial(e){return Object.entries(e).forEach((([s,r])=>{(r instanceof t||null===r)&&(e[s]=void 0)})),e}addBuffer(e,t){return super.addBuffer(e,t),this}setParams(e){return super.setParams(e),this}setMaterials(e){return null!=e&&Object.keys(e).length>0&&(this.main.materials=e),this}getMaterials(){return this.main.materials}cleanMaterials(){let e,t={};for(let s of Object.values(this.main.materials))"function"==typeof s.clone&&(e=s.clone(),t[e.name]=this._cleanMaterial(e));return this.setMaterials(t),this}package(e){return super.package(e),this.main.materials=MaterialUtils.getMaterialsJSON(this.main.materials),this}hasMultiMaterial(){return Object.keys(this.main.multiMaterialNames).length>0}getSingleMaterial(){return Object.keys(this.main.materials).length>0?Object.entries(this.main.materials)[0][1]:null}processMaterialTransport(e,t){for(let s=0;s<this.main.cloneInstructions.length;s++)MaterialUtils.cloneMaterial(e,this.main.cloneInstructions[s],t);let s;if(this.hasMultiMaterial())s=[],Object.entries(this.main.multiMaterialNames).forEach((([t,r])=>{s[t]=e[r]}));else{const t=this.getSingleMaterial();null!==t&&(s=e[t.name],s||(s=t))}return s}}class GeometryTransport extends DataTransport{constructor(e,t){super(e,t),this.main.type="GeometryTransport",this.main.geometryType=0,this.main.geometry={},this.main.bufferGeometry=null}loadData(e){return super.loadData(e),this.main.type="GeometryTransport",this.setGeometry(e.geometry,e.geometryType)}getGeometryType(){return this.main.geometryType}setParams(e){return super.setParams(e),this}setGeometry(e,t){return this.main.geometry=e,this.main.geometryType=t,e instanceof s&&(this.main.bufferGeometry=e),this}package(e){super.package(e);const t=this.main.geometry.getAttribute("position"),s=this.main.geometry.getAttribute("normal"),r=this.main.geometry.getAttribute("uv"),i=this.main.geometry.getAttribute("color"),a=this.main.geometry.getAttribute("skinIndex"),n=this.main.geometry.getAttribute("skinWeight"),o=this.main.geometry.getIndex();return this._addBufferAttributeToTransferable(t,e),this._addBufferAttributeToTransferable(s,e),this._addBufferAttributeToTransferable(r,e),this._addBufferAttributeToTransferable(i,e),this._addBufferAttributeToTransferable(a,e),this._addBufferAttributeToTransferable(n,e),this._addBufferAttributeToTransferable(o,e),this}reconstruct(e){if(this.main.bufferGeometry instanceof s)return this;this.main.bufferGeometry=new s;const t=this.main.geometry;this._assignAttribute(t.attributes.position,"position",e),this._assignAttribute(t.attributes.normal,"normal",e),this._assignAttribute(t.attributes.uv,"uv",e),this._assignAttribute(t.attributes.color,"color",e),this._assignAttribute(t.attributes.skinIndex,"skinIndex",e),this._assignAttribute(t.attributes.skinWeight,"skinWeight",e);const n=t.index;if(null!=n){const t=e?n.array.slice(0):n.array;this.main.bufferGeometry.setIndex(new r(t,n.itemSize,n.normalized))}const o=t.boundingBox;null!==o&&(this.main.bufferGeometry.boundingBox=Object.assign(new i,o));const l=t.boundingSphere;return null!==l&&(this.main.bufferGeometry.boundingSphere=Object.assign(new a,l)),this.main.bufferGeometry.uuid=t.uuid,this.main.bufferGeometry.name=t.name,this.main.bufferGeometry.type=t.type,this.main.bufferGeometry.groups=t.groups,this.main.bufferGeometry.drawRange=t.drawRange,this.main.bufferGeometry.userData=t.userData,this}getBufferGeometry(){return this.main.bufferGeometry}_addBufferAttributeToTransferable(e,t){if(null!=e){const s=t?e.array.slice(0):e.array;this.transferables.push(s.buffer)}return this}_assignAttribute(e,t,s){if(e){const i=s?e.array.slice(0):e.array;this.main.bufferGeometry.setAttribute(t,new r(i,e.itemSize,e.normalized))}return this}}class MeshTransport extends GeometryTransport{constructor(e,t){super(e,t),this.main.type="MeshTransport",this.main.materialsTransport=new MaterialsTransport}loadData(e){return super.loadData(e),this.main.type="MeshTransport",this.main.meshName=e.meshName,this.main.materialsTransport=(new MaterialsTransport).loadData(e.materialsTransport.main),this}setParams(e){return super.setParams(e),this}setMaterialsTransport(e){return e instanceof MaterialsTransport&&(this.main.materialsTransport=e),this}getMaterialsTransport(){return this.main.materialsTransport}setMesh(e,t){return this.main.meshName=e.name,super.setGeometry(e.geometry,t),this}package(e){return super.package(e),null!==this.main.materialsTransport&&this.main.materialsTransport.package(e),this}reconstruct(e){return super.reconstruct(e),this}}class ObjectUtils{static serializePrototype(e,t,s,r){let i,a=[],n="";r?(n=e.toString()+"\n\n",i=t):i=e;for(let e in i){let t=i[e],s=t.toString();"function"==typeof t&&a.push("\t"+e+": "+s+",\n\n")}n+=s+(r?".prototype":"")+" = {\n\n";for(let e=0;e<a.length;e++)n+=a[e];return n+="\n}\n;",n}static serializeClass(e){return e.toString()+"\n\n"}}class ObjectManipulator{static applyProperties(e,t,s){if(null==e||null==t)return;let r,i,a;for(r in t)i="set"+r.substring(0,1).toLocaleUpperCase()+r.substring(1),a=t[r],"function"==typeof e[i]?e[i](a):(e.hasOwnProperty(r)||s)&&(e[r]=a)}}class MaterialStore{constructor(e){if(this.materials={},e){const e=new n({color:14479871});e.name="defaultMaterial";const t=new n({color:14479871});t.name="defaultVertexColorMaterial",t.vertexColors=o;const s=new l;s.name="defaultLineMaterial";const r=new u({size:.1});r.name="defaultPointMaterial",this.materials[e.name]=e,this.materials[t.name]=t,this.materials[s.name]=s,this.materials[r.name]=r}}addMaterials(e,t){if(null==e&&(e={}),Object.keys(e).length>0){let s;for(const r in e)s=e[r],MaterialUtils.addMaterial(this.materials,s,r,!0===t)}}getMaterials(){return this.materials}getMaterial(e){return this.materials[e]}clearMaterials(){this.materials={}}}class WorkerTaskManagerDefaultRouting{static comRouting(e,t,s,r,i){let a=t.data;"init"===a.cmd?null!=s?s[r](e,a.workerId,a.config):r(e,a.workerId,a.config):"execute"===a.cmd&&(null!=s?s[i](e,a.workerId,a.config):i(e,a.workerId,a.config))}}class WorkerTaskManager{constructor(e){this.taskTypes=new Map,this.verbose=!1,this.maxParallelExecutions=e||4,this.actualExecutionCount=0,this.storedExecutions=[],this.teardown=!1}setVerbose(e){return this.verbose=e,this}setMaxParallelExecutions(e){return this.maxParallelExecutions=e,this}getMaxParallelExecutions(){return this.maxParallelExecutions}supportsTaskType(e){return this.taskTypes.has(e)}registerTaskType(e,t,s,r,i,a){let n=!this.supportsTaskType(e);if(n){let n=new WorkerTypeDefinition(e,this.maxParallelExecutions,i,this.verbose);n.setFunctions(t,s,r),n.setDependencyDescriptions(a),this.taskTypes.set(e,n)}return n}registerTaskTypeModule(e,t){let s=!this.supportsTaskType(e);if(s){let s=new WorkerTypeDefinition(e,this.maxParallelExecutions,!1,this.verbose);s.setWorkerModule(t),this.taskTypes.set(e,s)}return s}async initTaskType(e,t,s){let r=this.taskTypes.get(e);if(r)if(r.status.initStarted)for(;!r.status.initComplete;)await this._wait(10);else r.status.initStarted=!0,r.isWorkerModule()?await r.createWorkerModules().then((e=>r.initWorkers(t,s))).then((e=>r.status.initComplete=!0)).catch((e=>console.error(e))):await r.loadDependencies().then((e=>r.createWorkers())).then((e=>r.initWorkers(t,s))).then((e=>r.status.initComplete=!0)).catch((e=>console.error(e)))}async _wait(e){return new Promise((t=>{setTimeout(t,e)}))}async enqueueForExecution(e,t,s,r){return new Promise(((i,a)=>{this.storedExecutions.push(new StoredExecution(e,t,s,i,a,r)),this._depleteExecutions()}))}_depleteExecutions(){let e=0;for(;this.actualExecutionCount<this.maxParallelExecutions&&e<this.storedExecutions.length;){let t=this.storedExecutions[e],s=this.taskTypes.get(t.taskType),r=s.getAvailableTask();if(r){this.storedExecutions.splice(e,1),this.actualExecutionCount++,new Promise(((e,s)=>{r.onmessage=function(s){"assetAvailable"===s.data.cmd?t.assetAvailableFunction instanceof Function&&t.assetAvailableFunction(s.data):e(s)},r.onerror=s,r.postMessage({cmd:"execute",workerId:r.getId(),config:t.config},t.transferables)})).then((e=>{s.returnAvailableTask(r),t.resolve(e.data),this.actualExecutionCount--,this._depleteExecutions()})).catch((e=>{t.reject("Execution error: "+e)}))}else e++}}dispose(){this.teardown=!0;for(let e of this.taskTypes.values())e.dispose();return this}}class WorkerTypeDefinition{constructor(e,t,s,r){this.taskType=e,this.fallback=s,this.verbose=!0===r,this.initialised=!1,this.functions={init:null,execute:null,comRouting:null,dependencies:{descriptions:[],code:[]},workerModuleUrl:null},this.workers={code:[],instances:new Array(t),available:[]},this.status={initStarted:!1,initComplete:!1}}getTaskType(){return this.taskType}setFunctions(e,t,s){this.functions.init=e,this.functions.execute=t,this.functions.comRouting=s,void 0!==this.functions.comRouting&&null!==this.functions.comRouting||(this.functions.comRouting=WorkerTaskManagerDefaultRouting.comRouting),this._addWorkerCode("init",this.functions.init.toString()),this._addWorkerCode("execute",this.functions.execute.toString()),this._addWorkerCode("comRouting",this.functions.comRouting.toString()),this.workers.code.push('self.addEventListener( "message", message => comRouting( self, message, null, init, execute ), false );')}_addWorkerCode(e,t){t.startsWith("function")?this.workers.code.push("const "+e+" = "+t+";\n\n"):this.workers.code.push("function "+t+";\n\n")}setDependencyDescriptions(e){e&&e.forEach((e=>{this.functions.dependencies.descriptions.push(e)}))}setWorkerModule(e){this.functions.workerModuleUrl=new URL(e,window.location.href)}isWorkerModule(){return null!==this.functions.workerModuleUrl}async loadDependencies(){let e=[],t=new c;t.setResponseType("arraybuffer");for(let s of this.functions.dependencies.descriptions){if(s.url){let r=new URL(s.url,window.location.href);e.push(t.loadAsync(r.href,(e=>{this.verbose&&console.log(e)})))}s.code&&e.push(new Promise((e=>e(s.code))))}this.verbose&&console.log("Task: "+this.getTaskType()+": Waiting for completion of loading of all dependencies."),this.functions.dependencies.code=await Promise.all(e)}async createWorkers(){let e;if(this.fallback)for(let t=0;t<this.workers.instances.length;t++)e=new MockedTaskWorker(t,this.functions.init,this.functions.execute),this.workers.instances[t]=e;else{let t=new Blob(this.functions.dependencies.code.concat(this.workers.code),{type:"application/javascript"}),s=window.URL.createObjectURL(t);for(let t=0;t<this.workers.instances.length;t++)e=new TaskWorker(t,s),this.workers.instances[t]=e}}async createWorkerModules(){for(let e,t=0;t<this.workers.instances.length;t++)e=new TaskWorker(t,this.functions.workerModuleUrl.href,{type:"module"}),this.workers.instances[t]=e}async initWorkers(e,t){let s=[];for(let r of this.workers.instances){let i=new Promise(((s,i)=>{let a;if(r.onmessage=s,r.onerror=i,t){a=[];for(let e=0;e<t.length;e++)a.push(t[e].slice(0))}r.postMessage({cmd:"init",workerId:r.getId(),config:e},a)}));s.push(i)}this.verbose&&console.log("Task: "+this.getTaskType()+": Waiting for completion of initialization of all workers."),await Promise.all(s),this.workers.available=this.workers.instances}getAvailableTask(){let e;return this.hasTask()&&(e=this.workers.available.shift()),e}hasTask(){return this.workers.available.length>0}returnAvailableTask(e){this.workers.available.push(e)}dispose(){for(let e of this.workers.instances)e.terminate()}}class StoredExecution{constructor(e,t,s,r,i,a){this.taskType=e,this.config=t,this.assetAvailableFunction=s,this.resolve=r,this.reject=i,this.transferables=a}}class TaskWorker extends Worker{constructor(e,t,s){super(t,s),this.id=e}getId(){return this.id}}class MockedTaskWorker{constructor(e,t,s){this.id=e,this.functions={init:t,execute:s}}getId(){return this.id}postMessage(e,t){let s=this,r={postMessage:function(e){s.onmessage({data:e})}};WorkerTaskManagerDefaultRouting.comRouting(r,{data:e},null,s.functions.init,s.functions.execute)}terminate(){}}export{DataTransport,DeUglify,GeometryTransport,MaterialStore,MaterialUtils,MaterialsTransport,MeshTransport,ObjectManipulator,ObjectUtils,WorkerTaskManager,WorkerTaskManagerDefaultRouting};
